/*
 * All files in the distribution of JTB, The Java Tree Builder are
 * Copyright 1997, 1998 by the Purdue Research Foundation of Purdue
 * University.  All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that this entire copyright notice is duplicated in all
 * such copies, and that any documentation, announcements, and
 * other materials related to such distribution and use acknowledge
 * that the software was developed at Purdue University, West Lafayette,
 * Indiana by Kevin Tao and Jens Palsberg.  No charge may be made
 * for copies, derivations, or distributions of this material
 * without the express written consent of the copyright holder.
 * Neither the name of the University nor the name of the author
 * may be used to endorse or promote products derived from this
 * material without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR ANY PARTICULAR PURPOSE.
 */

//
// Class JavaStringMaker visits a java code brach of the tree and returns a
// pretty printed string representation of the subtree.
//

package EDU.purdue.jtb.misc;

import EDU.purdue.jtb.syntaxtree.Node;
import EDU.purdue.jtb.visitor.JavaPrinter;
import java.io.*;

public class JavaStringMaker {
   private StringWriter buffer;
   private JavaPrinter printer;
   private Spacing spc;

   public JavaStringMaker()            { this(new Spacing(3)); }
   public JavaStringMaker(Spacing s)   { spc = s; }

   public String javaString(Node javaNode) {
      buffer = new StringWriter();
      printer = new JavaPrinterWrapper(buffer, spc);

      javaNode.accept(printer);
      printer.flushWriter();
      return buffer.toString();
   }
}

class JavaPrinterWrapper extends JavaPrinter {
   JavaPrinterWrapper(Writer out, Spacing s) {
      super(out);
      spc = s;
   }
}
