/*
 * All files in the distribution of JTB, The Java Tree Builder are
 * Copyright 1997, 1998 by the Purdue Research Foundation of Purdue
 * University.  All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that this entire copyright notice is duplicated in all
 * such copies, and that any documentation, announcements, and
 * other materials related to such distribution and use acknowledge
 * that the software was developed at Purdue University, West Lafayette,
 * Indiana by Kevin Tao and Jens Palsberg.  No charge may be made
 * for copies, derivations, or distributions of this material
 * without the express written consent of the copyright holder.
 * Neither the name of the University nor the name of the author
 * may be used to endorse or promote products derived from this
 * material without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR ANY PARTICULAR PURPOSE.
 */

//
// Class Spacing is used for of pretty printing to provide necessary
// indentation.
//

package EDU.purdue.jtb.misc;

import java.io.PrintWriter;

public class Spacing {
   public final int INDENT_AMT;

   public String spc = "";
   public int indentLevel = 0;

   public Spacing(int indentAmt) {
      INDENT_AMT = indentAmt;
   }

   public String toString() {
      return spc;
   }

   public void updateSpc(int numIndentLvls) {
      indentLevel += numIndentLvls;

      if ( numIndentLvls < 0 )
         spc = spc.substring(-1 * numIndentLvls * INDENT_AMT);
      else if ( numIndentLvls > 0 ) {
         StringBuffer buf = new StringBuffer(spc);

         for ( int i = 0; i < numIndentLvls * INDENT_AMT; ++i )
            buf.append(" ");

         spc = buf.toString();
      }
   }
}
