/*
 * All files in the distribution of JTB, The Java Tree Builder are
 * Copyright 1997, 1998 by the Purdue Research Foundation of Purdue
 * University.  All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that this entire copyright notice is duplicated in all
 * such copies, and that any documentation, announcements, and
 * other materials related to such distribution and use acknowledge
 * that the software was developed at Purdue University, West Lafayette,
 * Indiana by Kevin Tao and Jens Palsberg.  No charge may be made
 * for copies, derivations, or distributions of this material
 * without the express written consent of the copyright holder.
 * Neither the name of the University nor the name of the author
 * may be used to endorse or promote products derived from this
 * material without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR ANY PARTICULAR PURPOSE.
 */

//
// Class UnicodeConverter contains some methods to convert unicode chars into
// their escape sequence form (provided by James Huang from the JavaCC
// mailing list).
//

package EDU.purdue.jtb.misc;

public class UnicodeConverter {
   public static void printout (String s)   {
      System.out.print(convertString(s));
   }
   // YOU MAY WANT TO MODIFY THIS. -- 07/02/97
   public static boolean isASCII(char c) {
      return ((int)c>=32 && (int)c<=126) || (c=='\r') || (c=='\n') || (c=='\t');
   }
   public static char hexToChar (int hex) {
      if (hex < 10)  return (char)(hex + (int)'0');
      else           return (char)(hex - 10 + (int)'a');
   }
   public static char[] unicodeToString(char c) {
      char[] ca = { '\\', 'u', '\0', '\0', '\0', '\0' };
      ca[2] = hexToChar(((int)c >> 12) & 0x0f);
      ca[3] = hexToChar(((int)c >>  8) & 0x0f);
      ca[4] = hexToChar(((int)c >>  4) & 0x0f);
      ca[5] = hexToChar(((int)c      ) & 0x0f);
      return ca;
   }
   public static String convertString(String s) {
      int len = s.length();
      StringBuffer sb = new StringBuffer();
      for (int i=0; i<len; i++) {
         char c = s.charAt(i);
         if (isASCII(c)) sb.append(c);
         else sb.append(unicodeToString(c));
      }
      return sb.toString();
   }
}

