/*
 * All files in the distribution of JTB, The Java Tree Builder are
 * Copyright 1997, 1998 by the Purdue Research Foundation of Purdue
 * University.  All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that this entire copyright notice is duplicated in all
 * such copies, and that any documentation, announcements, and
 * other materials related to such distribution and use acknowledge
 * that the software was developed at Purdue University, West Lafayette,
 * Indiana by Kevin Tao and Jens Palsberg.  No charge may be made
 * for copies, derivations, or distributions of this material
 * without the express written consent of the copyright holder.
 * Neither the name of the University nor the name of the author
 * may be used to endorse or promote products derived from this
 * material without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR ANY PARTICULAR PURPOSE.
 */

//
// Class VarInfo stores variable information -- its type, name, and
// initializer.
//

package EDU.purdue.jtb.misc;

import java.io.*;

public class VarInfo {
   private String type;
   private String name;
   private String initializer;

   public VarInfo(String tp, String nm) {
      this(tp, nm, null);
   }

   public VarInfo(String tp, String nm, String init) {
      type = tp;
      name = nm;
      initializer = init;
   }

   public String getType()        { return type; }
   public String getName()        { return name; }
   public String getInitializer() { return initializer; }

   public String toString()       { return getVarDeclString(); }

   public String getVarDeclString() {
      StringWriter buf = new StringWriter();
      PrintWriter out = new PrintWriter(buf);

      out.print(type + " " + name);

      if ( initializer == null ) out.print(";");
      else                       out.print(" = " + initializer + ";");

      out.flush();
      out.close();
      return buf.toString();
   }
}
